////////////////////////////////////////////////////////////////////////////////
//  
//  FSEventsWrapper.h
//  
//  KPToolbox
//  
//  Created by Konstantin Pavlikhin on 22/03/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import <CoreServices/CoreServices.h>

@protocol FSEventsListener;

@class FSEvent;

@interface FSEventsWrapper : NSObject

@property(readwrite, assign) id<FSEventsListener> delegate;

@property(readwrite, retain) NSArray* pathsToWatch;

@property(readwrite, assign) CFTimeInterval latency;

@property(readwrite, getter = isWatching) BOOL watching;

@property(readwrite, retain) FSEvent* lastEvent;

@property(readwrite, retain) NSRunLoop* runLoop;

- (void) startWatching;

- (FSEventStreamRef) createEventStream;

- (void) flushAsync;

- (void) flushSync;

- (void) invalidateStream;

- (void) scheduleWithRunLoop: (NSRunLoop*) runLoop;

- (void) startStream;

- (void) stopStream;

- (void) unschedule;

- (void) stopWatching;

@end
