////////////////////////////////////////////////////////////////////////////////
//  
//  Property.h
//  
//  KPToolbox
//  
//  Created by Konstantin Pavlikhin on 16/04/11.
//  
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>

#import <objc/runtime.h>

enum AccessType
{
  AccessTypeUnknown,
  
  AccessTypeReadOnly,
  
  AccessTypeReadWrite
};

enum SetterSemantics
{
  SetterSemanticsUnknown,
  
  SetterSemanticsAssign,
  
  SetterSemanticsRetain,
  
  SetterSemanticsCopy
};

@interface Property : NSObject
{
  @private
    objc_property_t property;
    
    NSArray* attributes;
    
    enum AccessType accessType;
    
    enum SetterSemantics setterSemantics;
}

+ (id) propertyWithObjectiveCProperty: (objc_property_t) property;

- (id) initWithObjectiveCProperty: (objc_property_t) property;

- (BOOL) hasAttribute: (NSString*) code;

- (enum SetterSemantics) setterSemantics;

- (enum AccessType) accessType;

- (NSString*) typeEncoding;

@end
